 %ifnz 0

/*** tlib * release 9.0 version %v %f * */
/* release 9.0 version 5 09-Aug-95,13:36:44 */

/*** CHANGE HISTORY ***/
. 1 FTP.PRG 25-May-95,12:54:00,`SEN' Initial Release                        
. 2 FTP.PRG 26-May-95,09:57:06,`SEN' Changed display                        
. 3 FTP.PRG 05-Jul-95,14:10:10,`SEN' fixed put                              
. 4 FTP.PRG 08-Aug-95,14:53:46,`SEN' Changed data port choice               
. 5 FTP.PRG 09-Aug-95,13:36:44,`SEN' Fixed ascii transfers, and empty dirs  
/*** CHANGE HISTORY ***/
 %endif


	include ftp.txt

	call version

	display *va=24

cmdloop	
	loop
		keyin *n, "ftp> ", command
		call execcommand
	repeat

execcommand	routine
flag		num		1

	call toupper using command

	match "ASCII" to command
	if (equal and not LESS)
		move MODEASC to mode
		display "Tranfer Mode: Ascii"
		return
	endif

	match "BINARY" to command
	if (equal and not LESS)
		move MODEBIN to mode
		display "Tranfer Mode: Binary"
		return
	endif

	match "?" to command
	if (equal and not LESS)
		move 2 to flag
		call help using flag
		return
	endif

	match "CDUP" to command
	if (equal and not LESS)
		call cdup
		return
	endif

	match "CD" to command
	if (equal and not LESS)
		call cd
		return
	endif

	match "CLOSE" to command
	if (equal and not LESS)
		call close
		return
	endif

	match "DEBUG" to command
	if (equal and not LESS)
		call debug
		return
	endif

	match "DEFAULTS" to command
	if (equal and not LESS)
		call defaults
		return	
	endif

	match "DELETE" to command
	if (equal and not LESS)
		move FALSE to multiple
		call delete
		return
	endif

	match "DIR" to command
	if (equal and not LESS)
		call dir
		return
	endif

	match "EXIT" to command
	if (equal and not LESS)
		stop
	endif

	match "HELP" to command
	if (equal and not LESS)
		move 1 to flag
		call help using flag
		return
	endif

	match "GET" to command
	if (equal and not LESS)
		display "F1 to Abort"
		move FALSE to multiple
		call get
		return
	endif

	match "LS" to command
	if (equal and not LESS)
		call dir
		return
	endif

	match "MDELETE" to command
	if (equal and not LESS)
		move TRUE to multiple
		call delete
		return
	endif

	match "MGET" to command
	if (equal and not LESS)
		display "F1 to Abort"
		move TRUE to multiple
		call get
		return
	endif

	match "MKDIR" to command
	if (equal and not LESS)
		call mkdir
		return
	endif

	match "OPEN" to command
	if (equal and not LESS)
		call open
		return
	endif

	match "PROMPT" to command
	if (equal and not LESS)
		call prompt
		return
	endif

	match "PUT" to command
	if (equal and not LESS)
		display "F1 to Abort"
		move FALSE to multiple
		call put
		return
	endif

	match "PWD" to command
	if (equal and not LESS)
		call pwd
		return
	endif

	match "QUIT" to command
	if (equal and not LESS)
		stop
	endif
	
	match "QUOTE" to command
	if (equal and not LESS)
		call quote
		return
	endif

	match "REMOTEHELP" to command
	if (equal and not LESS)
		call remotehelp
		return
	 endif
	
	match "REMOTESTATUS" to command
	if (equal and not LESS)
		call remotestatus
		return
	endif

	match "RMDIR" to command
	if (equal and not LESS)
		call rmdir
		return
	endif

	match "STATUS" to command
	if (equal and not LESS)
		call status
		return
	endif

	match "TYPE" to command
	if (equal and not LESS)
		call type
		return
	endif

	match "USER" to command
	if (equal and not LESS)
		call user
		return
	endif

	match "VERBOSE" to command
	if (equal and not LESS)
		call verbose
		return
	endif

	display "Invalid Command : ", command	
	return
	endroutine


cdup		routine				.	issue cd / to remote host

	if (not connected)
		display "Not Connected"
		return
	endif
	pack ctrlsend with "CDUP", CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display "---> CDUP"
	endif

	call ctrlrecvloop

	return
	endroutine


cd		routine

	if (not connected)
		display "Not Connected"
		return
	endif
	bump command by 2
	if eos
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	pack ctrlsend with "CWD ", command, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> CWD ", command
	endif

	call ctrlrecvloop

	return
	endroutine


close	routine

	if (not connected)
		return
	endif
	pack ctrlsend with "QUIT", CR, LF
	call ctrlsend
	if (comerror)
		return
	endif
	if (debugflag)
		display "---> QUIT"
	endif

	call ctrlrecvloop

	if (comerror or not connected)
		return
	endif

	comclose control
	comclose data
	move FALSE to connected, comerror
	return
	endroutine


debug	routine

	if (debugflag)
		display "Debug Mode Off"
		move FALSE to debugflag
	else
		display "Debug Mode On"
		move TRUE to debugflag
	endif
	return
	endroutine


defaults	routine

	move TRUE to verbose
	move FALSE to debugflag
	move TRUE to prompt
	move MODEASC to mode

	display "Verbose On"
	display "Debug Off"
	display "Prompt On"
	display "Transfer Mode ASCII"
	return
	endroutine


delete	routine
flag		init		"2"
size		num		2
answer	char		1

	if (not connected)
		display "Not Connected"
		return
	endif
	if (multiple)
		bump command by 7
		if eos
			return
		endif
	else
		bump command by 6
		if eos
			return
		endif
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	move command to filework
	if (multiple)
		call list using flag
		if (comerror or not connected)
			return
		endif
	endif
	loop
		if (multiple)
			move files to filework
			movesize filework to size
			if (size < 2)
				return
			endif
			scan CR in filework
			if (not equal)
				return
			endif
			bump filework by -1
			lenset filework
			reset filework
			movesize filework to size
			bump files by (size + 2)
			if eos
				move "X" to flag
			endif				
		endif
		if (prompt)
			keyin *kcon, "Delete ", *dv, filework, " ?(Y/N):", answer
		else
			move "Y" to answer
		endif
		if ("Y" = answer or "y" = answer)
			pack ctrlsend with "DELE ", filework, CR, LF
			call ctrlsend
			if (comerror)
				display "Send Error"
				return
			endif
			if (debugflag)
				display *ll, "---> DELE ", filework
			endif
			call ctrlrecvloop
			if (comerror or not connected)
				return
			endif
		endif
		break if (not multiple or flag = "X")
	repeat
	return
	endroutine


dir		routine
flag	char 1
dspctr	num "00"
size	num 2

	if (not connected)
		display "Not Connected"
		RETURN
	endif
	move "1" to flag
	bump command by 3
	if (not EOS)
		loop
			cmatch " " to command
			if equal
				bump command
				if eos
					clear command
					break
				endif
			else
				break
			endif
		repeat
		move command to filework
	else
		clear filework
	endif
	call list using flag
	if (comerror or not connected)
		return
	endif

	move "00" to dspctr
	loop
		move files to filework
		movesize filework to size
		if (size < 2)
			return
		endif
		if (dspctr = 24)
			keyin *kcon, "Enter a Key to Continue", flag
			move "00" to dspctr
		endif

		scan CR in filework
		if (not equal)
			return
		endif
		bump filework by -1
		lenset filework
		reset filework
		movesize filework to size
		display *ll, filework
		bump files by (size + 2)
		if EOS
			return
		endif
		add 1 to dspctr
	repeat

	endroutine
	

get		routine
answer	char		1
size		num		3
flag		init		"2"

	if (not connected)
		display "Not Connected"
		return
	endif
	if (multiple)
		bump command by 4
		if eos
			return
		endif
	else
		bump command by 3
		if eos
			return
		endif
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	move command to filework
	if (multiple)
		call list using flag
		if (comerror or not connected)
			return
		endif
	endif
	loop
		if (multiple)
			move files to filework
			movesize filework to size
			if (size < 2)
				return
			endif
			scan CR in filework
			if (not equal)
				return
			endif
			bump filework by -1
			lenset filework
			reset filework
			movesize filework to size
			bump files by (size + 2)
			if eos
				move "X" to flag
			endif				
		endif
		if (prompt and multiple)
			keyin *kcon, "Get ", *dv, filework, " ?(Y/N):", answer
		else
			move "y" to answer
		endif
		if ("Y" = answer or "y" = answer)
			call getfile
			if (comerror or not connected)
				return
			endif
		endif
		break if (not multiple or flag = "X")
	repeat
	return
	endroutine


mkdir	routine

	if (not connected)
		display "Not Connected"
		return
	endif
	bump command by 5
	if eos
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	pack ctrlsend with "MKD ", command, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> MKD ", command
	endif

	call ctrlrecvloop

	return
	endroutine
	

rmdir	routine

	if (not connected)
		display "Not Connected"
		return
	endif
	bump command by 5
	if eos
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	pack ctrlsend with "RMD ", command, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> RMD ", command
	endif

	call ctrlrecvloop

	return
	endroutine


type		routine
work		char		6

	bump command by 4
	if eos
		if (mode = MODEASC)
			display "Transfer Mode : Ascii"
		else if (mode = MODEBIN)
			display "Transfer Mode : Binary"
		endif
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				if (mode = MODEASC)
					display "Transfer Mode : Ascii"
				else if (mode = MODEBIN)
					display "Transfer Mode : Binary"
				endif
				clear command
				return
			endif
		else
			break
		endif
	repeat

	chop command into work
	call toupper using work

	if (work = "BINARY")
		move MODEBIN to mode
		display "Tranfer Mode: Binary"
	else
		match "ASCII" to work
		if equal 
			move MODEASC to mode
			display "Tranfer Mode: Ascii"
		else
			reset command
			display "SYNTAX ERROR: ", command
		endif
	endif
	return
	endroutine
	

put		routine

	if (not connected)
		display "Not Connected"
		return
	endif

	bump command by 3
	if eos
		return
	endif

	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	move command to filework
	call putfile
	if (comerror or not connected)
		return
	endif

	return
	endroutine


open		routine

	bump command by 4
	if EOS
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if EOS
				clear command
				break
			endif
		else
			break
		endif
	repeat
	move command to host
	pack opnstr with "tcpclient ", host, " 21"

.	call defaults
	
	comclose control
	comclose data

	comopen control, opnstr

	move TRUE to connected
	move FALSE to comerror
	display "Connected to ", host

	call ctrlrecvloop
	if (comerror or not connected)
		return
	endif

	if (code != "220")
		return
	endif

	keyin "Name: ", user

	call login

	return
	endroutine


prompt	routine

	if (prompt)
		display "Prompt Mode Off"
		move FALSE to prompt
	else
		display "Prompt Mode On"
		move TRUE to prompt
	endif
	return
	endroutine


pwd		routine

	pack ctrlsend with "PWD", CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> PWD"
	endif

	call ctrlrecvloop
	if (comerror or not connected)
		return
	endif

	if (code = "257" and not verbose)
		reset ctrlrecv
		display *ll, ctrlrecv
	endif
	return
	endroutine


quote	routine

	if (not connected)
		display "Not Connected"
		return
	endif
	bump command by 5
	if eos
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	pack ctrlsend with "SITE ", command, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> SITE ", command
	endif

	call ctrlrecvloop

	return
	endroutine


remotestatus	routine

	if (not connected)
		display "Not Connected"
		return
	endif
	bump command by 12
	if eos
		clear command
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	pack ctrlsend with "STAT ", command, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> STAT ", command
	endif

	call ctrlrecvloop

	return
	endroutine


user		routine

	if (not connected)
		display "Not Connected"
		return
	endif
	bump command by 4
	if eos
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	move command to user
	call login
	return
	endroutine


status	routine

	if (connected)
		display *ll, "Connected to host: ", host
	else
		display "Not Connected"
	endif
	
	if (verbose)
		display "Verbose: On"
	else
		display "Verbose: Off"
	endif

	if (debugflag)
		display "Debug: On"
	else
		display "Debug: Off"
	endif

	if (prompt)
		display "Prompt: On"
	else
		display "Prompt: Off"
	endif

	if (mode)
		display "Mode: Binary"
	else
		display "Mode: Ascii"
	endif

	if (connected)
		display *ll, "User Name: ", user
	endif
	
	endroutine
	return


verbose	routine

	if (verbose)
		display "Verbose Off"
		move FALSE to verbose
	else
		display "Verbose On"
		move TRUE to verbose
	endif
	return
	endroutine


remotehelp	routine
topic 	char		40

	if (not connected)
		display "Not Connected"
		return
	endif
	bump command by 10
	if eos
		clear command
		return
	endif
	loop
		cmatch " " to command
		if equal
			bump command
			if eos
				clear command
				break
			endif
		else
			break
		endif
	repeat
	move command to topic
	pack ctrlsend with "HELP ", topic, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> HELP ", topic
	endif

	call ctrlrecvloop

	return
	endroutine


list	routine	flag
flag		char		@
size		num		3
tmpmode	num		1

	move mode to tmpmode
	move MODEASC to mode
	call dataport
	move tmpmode to mode

	if (comerror or not connected)
		comclose data
		return
	endif

	movesize filework to size
	
	if (flag = "1")
		if (size)
			pack ctrlsend with "LIST ", filework, CR, LF
		else
			pack ctrlsend with "LIST", CR, LF
		endif
	else
		if (size)
			pack ctrlsend with "NLST ", filework, CR, LF
		else
			pack ctrlsend with "NLST ", CR, LF
		endif
	endif
	call ctrlsend
	if (comerror)
		comclose data
		return
	endif
	if (debugflag and flag = "1")
		display *ll, "---> LIST ", filework
	else if (debugflag and flag = "2")
		display *ll, "---> NLST ", filework
	endif
	call ctrlrecvloop
	if (code != "125" and code != "150")
		clear files
		comclose data
		return
	endif
	move TRUE to getmit
	trap breaktrap if F1
	trap closed if io
	clear files
	move FALSE to closed
	loop
		call datarecv
		if (comerror)
			move FALSE to getmit
			move FALSE to comerror
			break
		endif
		append databuf to files
		clear databuf
	repeat


	trapclr all
	reset files
	comclose data
	call ctrlrecvloop
.	comclose data
	return
	endroutine


getfile	routine
answer	char		1
size		num		3
lpsav	num		3
lpnew	num		3

	call dataport
	if (comerror or not connected)
		return
	endif

	pack ctrlsend with "RETR ", filework, CR, LF
	call ctrlsend
	if (comerror)
		return
	endif
	if (debugflag)
		display *ll, "---> RETR ", filework
	endif
	call ctrlrecvloop
	if (code != "125" and code != "150")
		return
	endif

	exist filework
	if (not OVER)
		keyin *kcon, *dv, filework:
			" Already Exists.  Replace?(Y/N):", answer
		if (answer = "n" or answer = "N")
			keyin "Enter New Filename: ", filework
		endif
	endif
		
	prep localfile, filework

	move TRUE to getmit
	trap breaktrap if f1	
	trap closed if io

	move FALSE to closed

	loop
		call datarecv
		if (comerror)
			move FALSE to getmit
			move FALSE to comerror
			comclose data
			close localfile
			break
		endif
		if (mode = MODEASC and version != VERDOS)
			clear datawork
			loop
				movesize databuf to size
				if equal
					break
				endif
				movelptr datawork to lpsav
				endset datawork
				append databuf to datawork
				reset datawork
				if (version = VERUNIX)
					scan CR in datawork
				else			.MAC
					scan LF in datawork
				endif
				if (equal)
					bump datawork by -1
					if (eos)
						clear datawork
						bump databuf by 1
						if (eos)
							break
						endif
					else
						lenset datawork
						reset datawork
						movelptr datawork to lpnew
						bump databuf by (lpnew - lpsav + 1)
						if (eos)
							break
						endif
					endif
				else
					break
				endif
			repeat
			movesize datawork to size
			if (size)
				sformat varsend to size
				move datawork to varsend
				write localfile, WRITESEQ; varsend
			endif
		else
			movesize databuf to size
			if (size)
				sformat varsend to size
				move databuf to varsend
				write localfile, WRITESEQ; varsend;
			endif
		endif
	repeat
	trapclr all
	call ctrlrecvloop

	return
	endroutine


putfile	routine
flag		num		1
size		num		3
curptr	num		3
curptr2	num		3
bumpamt	num		1

	exist filework
	if (OVER)
		display *ll, filework, ": Invalid File"
		return
	endif
	open localfile, filework

	call dataport
	if (comerror or not connected)
		close localfile
		return
	endif

	pack ctrlsend with "STOR ", filework, CR, LF
	call ctrlsend
	if (comerror)
		close localfile
		return
	endif
	if (debugflag)
		display *ll, "---> STOR ", filework
	endif
	call ctrlrecvloop
	if (code != "125" and code != "150")
		close localfile
		return
	endif

	move TRUE to putmit
	trap breaktrap if F1
	trap closed if io

	move FALSE to closed

	loop
		clear databuf
		read localfile, READSEQ; databuf

		if (OVER)
			break
		endif
		if (mode = MODEASC and version != VERDOS)
			move 2 to flag
			clear datawork
			move 1 to curptr
			movesize databuf to size
			sformat varsend to size
			move databuf to varsend
			loop
				scan LF in varsend
				if (equal)
					movefptr varsend to curptr2
					bump varsend by -1
					if (eos)
						move 1 to bumpamt
					else
						move 2 to bumpamt
					endif
					lenset varsend
					if (curptr != curptr2)
						reset varsend to curptr
						append varsend to datawork
					endif
					append CR to datawork
					append LF to datawork
					endset varsend
					setlptr varsend
					bump varsend by bumpamt
					if (eos)
						break
					else
						movefptr varsend to curptr
					endif
				else
					append varsend to datawork
					break
				endif
			repeat
			reset datawork
			call datasend using flag
		else
			move 1 to flag
			call datasend using flag
		endif
		if (comerror)
			display "Transmission Error"
			break
		endif
	repeat

	trapclr all

	move FALSE to putmit
	move FALSE to comerror
	comclose data
	close localfile

	debug
	call ctrlrecvloop

	return
	endroutine


dataport routine
loopcnt	num		3
time	char	14
temp1	char	3
temp2	char	3
num1	num		3
num2	num		3

	move "GETLOCALADDR" to addrip
	comctl control, addrip
	
	for	loopcnt from 1 to 3			prepares addr str to be sent
		scan "." in addrip			to remote host
		if (not equal)
			move FALSE to connected
			return
		endif
		cmove "," to addrip
	repeat
	scan " " in addrip
	if (not equal)
		move FALSE to connected
		return
	endif
	cmove "," to addrip

	clock timestamp to time
	bump time by 11
	move time to loopcnt
	add 1 to counter
	add loopcnt to counter

	move (16777 + counter) to port
	pack opnstr with "tcpserver ", port
	comopen data, opnstr

	move TRUE to connected
		
	mod "256" to port giving num1

	divide "256" into port giving num2
	if (num1 > 127)
		sub "1" from num2
	endif
	move num2 to temp1
	squeeze temp1 to temp2
	append temp2 to addrip

	append "," to addrip

	move num1 to temp1
	squeeze temp1 to temp2
	append temp2 to addrip
	reset addrip

	if (mode = MODEASC)
		pack ctrlsend with "TYPE A", CR, LF
	else
		pack ctrlsend with "TYPE I", CR, LF
	endif
	
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag and mode)
		display *ll, "---> TYPE I"
	else if (debugflag and not mode)
		display *ll, "---> TYPE A"
	endif
	call ctrlrecvloop
	if (code != "200")
		return
	endif

	pack ctrlsend with "PORT ", addrip, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> PORT ", addrip
	endif
	call ctrlrecvloop
	return
	endroutine
 

login	routine

acct	char 64
pswd	char 64

	pack ctrlsend with "USER ", user, CR, LF
	call ctrlsend
	if (comerror)
		display "Send Error"
		return
	endif
	if (debugflag)
		display *ll, "---> USER ", user
	endif

	call ctrlrecvloop
	if (comerror or not connected)
		return
	endif

	if (code = "331")
		keyin *eson, "PASSWORD: ", pswd
		pack ctrlsend with "PASS ", pswd, CR, LF
		call ctrlsend
		if (comerror)
			display "Send Error"
			return
		endif
		if (debugflag)
			display *ll, "---> PASS XXXX"
		endif
		call ctrlrecvloop
		if (code != "332")
			return
		endif
	endif
	if (code = "332")
		keyin "ACCOUNT: ", acct
		pack ctrlsend with "ACCT ", acct, CR, LF
		call ctrlsend
		if (comerror)
			display "Send Error"
			return
		endif
		if (debugflag)
			display *ll, "---> ACCT ", acct
		endif
		call ctrlrecvloop
	endif
	return
	endroutine
	

ctrlrecvloop	routine
term	char	4

	move TRUE to first
	loop
		call ctrlrecv
		if (comerror)
			display "Receive Error"
			clear code
			return
		endif
		if (verbose)
			display ctrlrecv
		endif
		if (first)
			move ctrlrecv to code
			bump ctrlrecv by 3
			cmatch "-" to ctrlrecv
			if (not equal)
				break
			endif
			reset ctrlrecv
			pack term with code, " "
			move FALSE to first
		else
			match term to ctrlrecv
			if (equal and not LESS)
				break
			endif
		endif
	repeat
	match "421" to code
	if (equal and not LESS)
		if (not verbose)
			display "Connection Closed"
		endif
		comclose control
		move FALSE to connected			
	endif
	return
	endroutine

ctrlrecv	routine
ctrlbuf		char 2048
ctrlleft	char 2048
	clear ctrlrecv
	clear ctrlbuf
	scan LF in ctrlleft
	if equal
		reset ctrlleft
		move ctrlleft to ctrlrecv
		clear ctrlleft
	else
		append ctrlleft to ctrlrecv
		clear ctrlleft
		loop
			recv control, BLOCK; ctrlbuf
			comwait control
			comtst control
			if (OVER and LESS)
 				move TRUE to comerror
				move FALSE to connected
				comclose control
				return
			else if (OVER and not LESS)
				continue
			endif
			recvclr control
			scan LF in ctrlbuf
			if equal
				reset ctrlbuf
				append ctrlbuf to ctrlrecv
				break
			else
				reset ctrlbuf
				append ctrlbuf to ctrlrecv
				clear ctrlbuf
			endif
		repeat
	endif
	reset ctrlrecv
	scan LF in ctrlrecv
	bump ctrlrecv
	if eos
		bump ctrlrecv by -2
	else
		move ctrlrecv to ctrlleft
		bump ctrlrecv by -3
	endif
	lenset ctrlrecv
	reset ctrlrecv
	move FALSE to comerror
	return
	endroutine		


ctrlsend	routine
varsize		int		3

	movesize ctrlsend to varsize
	sformat varsend to varsize
	move ctrlsend to varsend

	send control, BLOCK; varsend
	comwait control
	comtst control
	if eos
		move TRUE to comerror
		move FALSE to connected
		comclose control
	else
		sendclr control
		move FALSE to comerror
	endif
	return
	endroutine


datarecv	routine	

	clear databuf
	recv data, BLOCK; databuf
	comwait
	comtst data
	if (less and over)
		move TRUE to closed
	endif
	if (closed)
		move TRUE to comerror
		move FALSE to closed
		return
	endif

	recvclr data	
	move FALSE to comerror
	return
	endroutine


datasend	routine	flag
flag	num	@
varsize	num	3


	if (flag = 1)
		movesize databuf to varsize
		sformat varsend to varsize
		move databuf to varsend
	else
		movesize datawork to varsize
		sformat varsend to varsize
		move datawork to varsend
	endif		

	send data, BLOCK; varsend

	comwait data
	comtst data
	if (closed)
		move TRUE to comerror
		move FALSE to closed
	else
		move FALSE to comerror
	endif

	return
	endroutine


help	routine	flag		flag = 1 for help and 2 for ?
flag	num	@
work	char 15

	if (flag = 1)
		bump command by 4
	else
		bump command
	endif
	
	if EOS
		call helplist
		return
	endif

	loop while (fchar(command) = " ")
		bump command
		if EOS
			call helplist
			return
		endif
	repeat

	chop command into work		
	call toupper using work

	match "?" to work
	if (equal and not LESS)
		display "?", *h=15, "Display Local Help"
		return
	endif

	match "HELP" to work
	if (equal and not LESS)
		display "HELP", *h=15, "Display Local Help"
		return
	endif

	match "ASCII" to work
	if (equal and not LESS)
		display "ASCII", *h=15, "Change Transfer Mode to Ascii"
		return
	endif

	match "BINARY" to work
	if (equal and not LESS)
		display "BINARY", *h=15, "Change Transfer Mode to Binary"
		return
	endif

	match "CDUP" to work
	if (equal and not LESS)
		display "CDUP", *h=15, "Change Remote Directory to Parent Directory"
		return
	endif

	match "CD" to work
	if (equal and not LESS)
		display "CD", *h=15, "Change Remote Directory"
		return
	endif

	match "CLOSE" to work
	if (equal and not LESS)
		display "CLOSE", *h=15, "Close FTP Connection"
		return
	endif

	match "DEBUG" to work
	if (equal and not LESS)
		display "DEBUG", *h=15, "Toggle Display of Commands Sent to Server"
		return
	endif

	match "DEFAULTS" to work
	if (equal and not LESS)
		display "DEFAULTS", *h=15, "Return Mode, Debug, Verbose, and Prompt to Default"
		return
	endif

	match "DELETE" to work
	if (equal and not LESS)
		display "DELETE", *h=15, "Delete Remote File"
		return
	endif

	match "DIR" to work
	if (equal and not LESS)
		display "DIR", *h=15, "List Remote Files"
		return
	endif

	match "EXIT" to work
	if (equal and not LESS)
		display "EXIT", *h=15, "Stop Program"
		return
	endif

	match "GET" to work
	if (equal and not LESS)
		display "GET", *h=15, "Get Remote File"
		return
	endif

	match "LS" to work
	if (equal and not LESS)
		display "LS", *h=15, "List Remote Files"
		return
	endif

	match "MDELETE" to work
	if (equal and not LESS)
		display "MDELETE", *h=15, "Delete Multiple Remote Files"
		return
	endif

	match "MGET" to work
	if (equal and not LESS)
		display "MGET", *h=15, "Get Multiple Remote Files"
		return
	endif

	match "MKDIR" to work
	if (equal and not LESS)
		display "MKDIR", *h=15, "Create Remote Directory"
		return
	endif

	match "OPEN" to work
	if (equal and not LESS)
		display "OPEN", *h=15, "Open FTP Connection to Remote Host"
		return
	endif

	match "PROMPT" to work
	if (equal and not LESS)
		display "PROMPT", *h=15, "Toggle Interactive Prompting on Multiple Commands"
		return
	endif

	match "PUT" to work
	if (equal and not LESS)
		display "PUT", *h=15, "Put File on Remote Host"
		return
	endif

	match "PWD" to work
	if (equal and not LESS)
		display "PWD", *h=15, "Display Current Remote Directory"
		return
	endif

	match "QUIT" to work
	if (equal and not LESS)
		display "QUIT", *h=15, "Stop Program"
		return
	endif

	match "QUOTE" to work
	if (equal and not LESS)
		display "QUOTE", *h=15, "Issue Command to Remote Host"
		return
	endif

	match "REMOTEHELP" to work
	if (equal and not LESS)
		display "REMOTEHELP" *h=15, "Issue Help Command to Remote Host"
		return
	endif

	match "REMOTESTATUS" to work
	if (equal and not LESS)
		display "REMOTESTATUS", *h=15, "Display Remote Status of FTP Connection"
		return
	endif

	match "RMDIR" to work
	if (equal and not LESS)
		display "RMDIR", *h=15, "Remove Directory From Remote Host"
		return
	endif

	match "STATUS" to work
	if (equal and not LESS)
		display "STATUS", *h=15, "Display Local Status of FTP Connection"
		return
	endif

	match "TYPE" to work
	if (equal and not LESS)
		display "TYPE", *h=15, "Set or Display Transfer Mode"
		return
	endif

	match "USER" to work
	if (equal and not LESS)
		display "USER", *h=15, "Send New User Information to Remote Host"
		return
	endif

	match "VERBOSE" to work
	if (equal and not LESS)
		display "VERBOSE", *h=15, "Toggle Display of Control Channel Communication"
		return
	endif

	display "Invalid Command : ", work
	return
	endroutine


helplist		routine

	display "?", 		*h=15, "DELETE", 	*h=30, "MKDIR",	*h=45, "REMOTESTATUS"
	display "ASCII", 	*h=15, "DIR", 		*h=30, "OPEN", 	*h=45, "RMDIR"
	display "BINARY", 	*h=15, "EXIT", 	*h=30, "PROMPT", 	*h=45, "STATUS"
	display "CD", 		*h=15, "GET", 		*h=30, "PUT", 		*h=45, "TYPE"
	display "CDUP", 	*h=15, "HELP", 	*h=30, "PWD", 		*h=45, "USER"
	display "CLOSE", 	*h=15, "LS", 		*h=30, "QUIT", 	*h=45, "VERBOSE"
	display "DEBUG", 	*h=15, "MDELETE", 	*h=30, "QUOTE"
	display "DEFAULTS", *h=15, "MGET", 	*h=30, "REMOTEHELP"
	return
	endroutine


version	routine
storage	char	20

	clock version into storage

	if (storage = "PCNET")
		move VERDOS to version
	else if (storage = "NETWARE")
		move VERDOS to version
	else if (storage = "PCDOS")
		move VERDOS to version
	else if (storage = "OS2")
		move VERDOS to version
	else if (storage = "OS2NET")
		move VERDOS to version
	else if (storage = "OS2NETWARE")
		move VERDOS to version
	else if (storage = "UNIX")
		move VERUNIX to version
	else if (storage = "MACINTOSH")
		move VERMAC to version
	else
		display "Undefined Version of DB\C : ", storage
		stop
	endif
	return
	endroutine


breaktrap		routine
telseq	init		0xff, 0xf4, 0xff, 0xf2

	if (putmit)
		move FALSE to putmit
	else if (getmit)
		move FALSE to getmit
		pack ctrlsend with telseq, "ABOR", CR, LF
		call ctrlsend
		if (comerror)
			display "send error"
			return
		endif
		if (debugflag)
			display "---> <IAC,IP,IAC,DM>ABOR"
		endif
	
	endif

	call ctrlrecvloop

	comclose data
	close localfile
	goto cmdloop

closed	routine

	move TRUE to closed
	return
	endroutine

toupper	routine		str
str			char		@
temp		char		1
upper		init "aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ"

	if (fchar(str) = " ")
		bump str
		if eos
			return
		endif
	endif
	reset temp

	loop
		if (fchar(str) = " ")
			break	
		endif
		cmove str to temp
		replace upper in temp
		cmove temp to str
		bump str
		if eos
			break
		endif
	repeat

	reset str

	return
	endroutine

