*
.
. this is an example of how to call the recvmail routine
.

msghead char 80[256]
msgtext char 80[256]
i3      int 3
n3      int 3
     display *es, "Sample program that fetches email messages"
     loop
          call recvmail with "mailhost.test.com", "user", "pswd", msghead, msgtext
          break if eos
          move 1 to i3
          loop
               movefptr msghead[i3] to n3
               break if equal
               display msghead[i3]
               add 1 to i3
          repeat
          setflag not equal
          move 1 to i3
          loop
               movefptr msgtext[i3] to n3
               break if equal
               display msgtext[i3]
               add 1 to i3
          repeat
          display *w=5
     repeat
     stop


*
.
. recvmail routine global variables
.
ht        init 0x09
cr        init 0x0D
crlf      init 0x0D, 0x0A
timeout   form "30"
response  char 100
sendtext  char @
messages  form 5

.
. receive mail routine
. messages are retrieved from the SMTP mail server specified by the mailhost 
. operand
.
recvmail  routine mailhost, name, passwd, header, message
mailhost  char @
name      char @
passwd    char @
header    char @[]
message   char @[]
cfile     comfile
count     dim 5
     move 0 to messages
     clear header
     clear message
     comopen cfile, ("TCPCLIENT " + mailhost + " 110")
     recv cfile, timeout; response
     wait cfile
     comtst cfile
     bump response by 4
     call send with ("USER " + name)
     call send with ("PASS " + passwd)
     call send with ("STAT") 
     if (messages = 0)
          setflag eos
          return
     endif
     move messages to count
     squeeze count to count
     call send with ("RETR " + count)
     call getmsg with header, message
     call send with ("DELE " + count)
     call send with ("QUIT")
     comclose cfile
     return

.
. send command and handle response if necessary
.
send     lroutine sendtext
c4   dim 4
i1   int 2
flag init "1"
     comclr cfile
     send cfile, timeout; *ll, sendtext, crlf
     comwait
     sendclr cfile
     recv cfile, timeout; response
     comwait
     comtst cfile
     move response to c4
     bump response by 4
     if (c4 = "-ERR")
          display "Error: ", *ll, response
     endif
     move sendtext to c4
     if (c4 = "STAT")
          scan " " in response
          bump response by -1
          lenset response
          reset response to 5
          move response to messages
     endif
     return
     endroutine

.
. finite state machine to retrieve the email message
. this function simply reads crlf delimited lines from the server
. until it encounters a line with just a single '.' on it
.
getmsg lroutine head, mess
head char @[]
mess char @[]
c1 dim 1
i1 int 2
i2 int 3
state int 1
hflag int 1
     move 0 to state
     move 1 to hflag
     move 0 to i1
     move 1 to i2
     loop
          recv cfile, timeout; c1
          comwait
          comtst cfile
          add 1 to i1
          if (state = 3) . display printable characters
               if (c1 = cr)
                    recv cfile, timeout; c1
                    comwait
                    comtst cfile
                    move 2 to state
               else 
                    if (c1 = ht)
                         move " " to c1
                    endif
                    if (hflag = 1)
                         append c1 to head[i2]
                    else
                         append c1 to mess[i2]
                    endif
                    if (i1 = 80)
                         move 2 to state
                    else 
                         continue
                    endif
               endif
          endif
          if (state = 0) . reading first character on line
               if (c1 = ".")
                    move 1 to state
                    continue
               else if (c1 = cr)
                    recv cfile, timeout; c1
                    comwait
                    comtst cfile
                    move 2 to state
                    if (hflag = 1)
                         move 0 to hflag
                         move 0 to i2
                    else
                         append " " to mess[i2]
                    endif
               else
                    if (c1 = ht)
                         move " " to c1
                    endif
                    if (hflag = 1)
                         append c1 to head[i2]
                    else
                         append c1 to mess[i2]
                    endif
                    move 3 to state
                    continue
               endif
          endif
          if (state = 1) . reading second character on line after "."
               if (c1 = cr)
                    recv cfile, timeout; c1
                    comwait
                    comtst cfile
                    break
               else
                    if (c1 = ht)
                         move " " to c1
                    endif
                    if (hflag = 1)
                         append c1 to head[i2]
                    else
                         append c1 to mess[i2]
                    endif
                    move 3 to state
                    continue
               endif
          endif
          if (state = 2) . read cr lf, or 80 characters
               add 1 to i2
               move 0 to i1
               move 0 to state
          endif
     repeat
     return
     endroutine



