.............................................................................
.
. this is an example of how to call the sendmail routine
.
. SSN - modification 03/07/01, fixed incorrect hex value in base64 encoder
.
.

msgtext char 80[10]
attachm char 80[10]

     display *es, "Sample program that sends an email with attachments"
     move "Hello," to msgtext[1]
     move "This is the body of the email." to msgtext[2]
     move "There are two files attached." to msgtext[3]
     move "file1.txt", attachm[1]
     move "file2.txt", attachm[2]
     call sendmail with "fromsmtpserver.com", "from@fromcompany.com":
          "to@tocompany.com", "email attachment test", msgtext, attachm
     display "Email has been sent", *w
     stop


.............................................................................
.
. send mail routine
. mail is sent using the SMTP mail server specified by the mailhost operand
. from and to are fully specified Internet email addresses
. subject is the subject of the email
. msg is an array of character variables that contains the message
. attach is an array of filenames to attach
.

crlf      init 0x0D, 0x0A
priority  init "3"         . priority is from 1-5, 1 is highest, 3 is normal


sendmail  routine mailhost, from, to, subject, msg, attach
mailhost  char @
from      char @
to        char @
subject   char @
msg       char @[]
attach    char @[]
filepath  char 80
cfile     comfile
i1        int 5
n1        int 5
c3        char 1
m1        int 3
j1        int 3
date      char 31
boundary  init "----=_NextPart_0293849df.938421"
     comopen cfile, ("TCPCLIENT " + mailhost + " 25")
     call send1 with "HELO"
     call send1 with ""
     call send1 with ("MAIL FROM: <" + from + ">")
     call send1 with ("RCPT TO: <" + to + ">")
     call send1 with "DATA"
     call setdate
     call send2 with ("Date: " + date)
     call send2 with ("To: " + to)
     call send2 with ("From: " + from)
     call send2 with ("Subject: " + subject)
     call send2 with ("MIME-Version: 1.0 (Generated by DBC)")
     call send2 with ("Content-Type: multipart/mixed; boundary=#"" + boundary + "#"")
     call send2 with ("X-Priority: " + priority)
     call send2 with (crlf + "--" + boundary) 
     call send2 with ("Content-Type: text/plain; charset=us-ascii")
     call send2 with ""
     type msg to i1, n1
     for i1 from 1 to n1
          if (msg[i1] = ".")
               call send2 with ". "
          else if (msg[i1] != "")
               call send2 with msg[i1]
          endif
     repeat
     type attach to i1, n1
     for i1 from 1 to n1
          if (attach[i1] = "") 
               break
          endif          
          call send2 with ("--" + boundary)
          call send2 with ("Content-Type: application/octet-stream")
          call send2 with ("Content-Transfer-Encoding: base64") 
          move attach[i1], filepath
          move filepath, attach[i1]
          movelptr attach[i1], m1
          for j1 from 1 to m1
               move attach[i1], c3
               if (c3 = "/" | c3 = "\")
                    reset filepath, (j1 + 1) 
               endif
               bump attach[i1]
          repeat
          reset attach[i1]
          call send2 with ("Content-Disposition: attachment; filename=#"" + filepath + "#"")
          call send2 with ""
          call sendfile with attach[i1]
          call send2 with ""
     repeat
     call send2 with (crlf + "--" + boundary + "--")	
     call send1 with "."
     call send1 with "QUIT"
     comclose cfile
     return

SEQ       form "-1"
d1        dim 1
timeout   form "30"
sendresp  char 100
sendtext  char @
filename  char @
afile     file binary, fix=1

.
. send line with wait for response
.
send1     lroutine sendtext
     comclr cfile
     send cfile, timeout; *ll, sendtext, crlf
     comwait
     sendclr cfile
     recv cfile, timeout; sendresp
     comwait
     comtst cfile
     return
     endroutine

.
. send line with no wait for response
.
send2     lroutine sendtext
     comclr cfile
     send cfile, timeout; *ll, sendtext, crlf
     comwait
     return
     endroutine

.
. send base64 encoded file with no wait for response
.
sendfile     lroutine filename
i2       int 1
pads     int 2
len      int 3
q        dim 1[3]
b64      dim 1[4]
     open afile, filename
     comclr cfile
     move 0, len
     loop
          move 3 to pads
          for i2 from 1 to 3 
               read afile, SEQ; q[i2]
               if over
                    break
               endif
               sub 1 from pads
          repeat
          if (pads != 3)
	       call ctob64 with q, pads, b64   
               send cfile, timeout; b64
               comwait cfile
               add 4, len
               if (len >= 71)
                    send cfile, timeout; crlf
                    comwait cfile
                    move 0, len
               endif
          endif 
          if (pads = 1 | pads = 2 | pads = 3)
              if (len != 0)
                   send cfile, timeout; crlf
                   comwait cfile
              endif 
              break
          endif
     repeat    
     close afile 
     return
     endroutine

.
. base64 encoding
.
ctob64   routine p, pad, b64@
pad      int @
p        char @[]     
b64@     char @[]
p1       char 1
p2       char 1
a1       int 3
a2       int 3
b64table char 1[64], initial "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M": 
                             "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z":
                             "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m":
                             "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z":
                             "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "+", "/"
                             
     call decval with p[1], a1
     move b64table[((a1 / 4) + 1)], b64@[1]
     move p[1], p1
     and 0x03, p1
     call decval with p1, a1
     mult 16, a1
     move p[2], p2
     and 0xF0, p2
     call decval with p2, a2
     div 16, a2     
     call chrval with a1, p1
     call chrval with a2, p2
     or p1, p2
     call decval with p2, a2
     move b64table[(a2 + 1)], b64@[2]
     if (pad = 2)
          move "=", b64@[3] 
          move "=", b64@[4]
     else 
          move p[2], p1
          and 0x0F, p1
          call decval with p1, a1
          mult 4, a1
          if (pad = 1)
               call chrval with 0, p2
          else
               move p[3], p2
               and 0xC0, p2
          endif 
          call decval with p2, a2
          div 64, a2
          call chrval with a1, p1
          call chrval with a2, p2
          or p1, p2
          call decval with p2, a2
          move b64table[(a2 + 1)], b64@[3]
          if (pad = 1)
               move "=", b64@[4]
          else
               move p[3], p2
               and 0x3F, p2
               call decval with p2, a2
               move b64table[(a2 + 1)], b64@[4]
          endif               
     endif
     return
     endroutine

.
. get ascii decimal value (0-255) for any given character
.
decval   routine c1, a1@
c1     char @
a1@    int @
mx     char 256
c2     char 1
h1     init 0x80
     move c1, c2
     and 0x80, c2
     if (c2 = h1) 
          reset mx, c1
          move (formptr mx + 31), a1@
     else 
          or 0x80, c1
          reset mx, c1
          move (formptr mx + 31), a1@
          sub 128, a1@          
     endif
     return
     endroutine

.
. get character from decimal value
.
chrval   routine a1, c1@
c1@    char @
a1     int @
hexvals  init 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F:
           0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F:
           0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F:
           0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F:
           0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F:
           0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F:
           0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F:
           0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F:
           0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D, 0x8E, 0x8F:
           0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9A, 0x9B, 0x9C, 0x9D, 0x9E, 0x9F:
           0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF:
           0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0xBE, 0xBF:
           0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF:
           0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF:
           0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF:
           0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0xFF  
     reset hexvals, (a1 + 1)
     move hexvals, c1@
     return
     endroutine

.
. set the date variable to "day, dd mmm yyyy hh:mm:ss -nnnn"
. where -nnnn is GMT offset (-0600 is US Central Standard Time).
.
setdate
work char 24
     clock calendar to work
     move work to date
     reset date to 3
     append ", " to date
     reset work to 9
     append work to date
     reset date to 7
     append " " to date
     reset work to 5
     append work to date
     reset date to 11
     append " " to date
     reset work to 12
     append work to date
     append " -0600" to date
     reset date
     return
     endroutine

.............................................................................

 


