. DB/C Release 9.0 
. HTTP 1.0 Server 
. Copyright 1995 Subject, Wills & Company 

 #ifnz 0
/*** tlib * release 9.0 version %v %f * */
/* release 9.0 version 1 25-May-95,12:50:30 */

/*** CHANGE HISTORY ***/
. 1 WEB.PRG 25-May-95,12:50:30,`SEN' Initial Release                        
/*** CHANGE HISTORY ***/
 #endif

	include web.txt
 %ifdef _DISPLAY
	display "web server"
	move TRUE to verbose
 %else
	move FALSE to verbose
 %endif

	make channel1 from channel
	make channel2 from channel
	make channel3 from channel
	make channel4 from channel
	make channel5 from channel
	make channel6 from channel
	make channel7 from channel
	make channel8 from channel
	make channel9 from channel

	loop
		comwait
		call procchan:channel1
		call procchan:channel2
		call procchan:channel3
		call procchan:channel4
		call procchan:channel5
		call procchan:channel6
		call procchan:channel7
		call procchan:channel8
		call procchan:channel9
	repeat
	stop
	
channel	class definition, make=makechannel
CR			init		0X0D
LF			init		0X0A
BLOCK		num		"-1"
READSEQ		num		"-1"
opnstr		init		"tcpserver 80"
reqend		char		2
webchan	comfile
objfile	file		binary, var=512
version	num		2
state	num		1
errcode	char		3
gotline	num		1
filename	char		20
databuf	char		512
varsend	char		512
linebuf	char		1024
extrabuf	char		512

makechannel	routine
	move 0.9 to version
	pack reqend with CR, LF
	comopen webchan, opnstr
	call firstrecv
	move WAITING to state
	return
	endroutine

newchannel	routine
	close objfile
	comclose webchan
	move 0.9 to version
	comopen webchan, opnstr
	call firstrecv
	move WAITING to state
	return
	endroutine

procchan		routine
	if (state < 0 or state > SENDERR)
		call newchannel
		return
	endif
	if (state = WAITING)
		call chkcnct
	endif
	if (state = REQINONE)
		call getreqone
	endif
	if (state = REQINTWO)
		call getreqtwo
	endif
	if (state = REQDONE)
		call starthead
	endif
	if (state = SENDHEAD)
		call chkhead
 	endif
	if (state = SENDHEADDONE)
		call startbody
	endif
	if (state = SENDBODY)
		call bodysend
	endif
	if (state = SENDERR)
		call chkerr
	endif
 	return
	endroutine 

firstrecv		routine
	clear databuf
	clear linebuf
	clear extrabuf	
	recv webchan, BLOCK; databuf
	return
	endroutine

chkcnct		routine
	comtst webchan
	if (not over and less)			. success
		move databuf to extrabuf
		move REQINONE to state
		return
	else if (over and not less)		. pending
		return
	else							. error or clear
		call newchannel
		return
	endif
	return
	endroutine

getreqone		routine
	call getline
	if (gotline = TRUE)
. have a crlf delimited linebuf
	 	call splitbuf
 %ifdef _DISPLAY
		display linebuf
 %endif
		call checkmethod
	endif
	return
	endroutine

getreqtwo		routine
	loop
		call getline
		if (gotline = TRUE)
		 	call splitbuf
 %ifdef _DISPLAY
			display linebuf
 %endif
			match reqend to linebuf
			if (equal)
				move REQDONE to state
				return
			endif
.  									add request parsing here
		else
			return
		endif
	repeat
	return
	endroutine

starthead		routine
	if (version != 0.9)
		pack databuf with "HTTP/1.0 200 OK", CR, LF, CR, LF
		call prepsend
		send webchan, BLOCK; varsend
		move SENDHEAD to state
	else
		move SENDHEADDONE to state
	endif
	return
	endroutine

chkhead		routine
	comtst webchan
	if (equal and not eos)			. success
		move SENDHEADDONE to state
		return
	else if (eos and not equal)		. pending
		return
	else							. error or clear
		call newchannel
		return
	endif
	return
	endroutine

startbody		routine
	open objfile, filename
	read objfile, READSEQ; databuf
	if (over)
		call newchannel
		return
	endif
	call prepsend
	send webchan, BLOCK; varsend
	move SENDBODY to state
	return
	endroutine

bodysend		routine
	loop
		comtst webchan
		if (equal and not eos)			. success
			read objfile, READSEQ; databuf
			if (over)
				call newchannel
				return
			endif
			call prepsend
			send webchan, BLOCK; varsend
		else if (eos and not equal)		. pending
			return
		else							. error or clear
			call newchannel
			return
		endif
	repeat		
	return
	endroutine

chkerr		routine
	comtst webchan
	if (eos and not equal)			. pending
		return
	else							. success, error or clear
		call newchannel
		return
	endif
	endroutine


splitbuf		routine			.  splits first line out of linebuf
crflag		num		1
	scan CR in linebuf
	if (equal)
		move TRUE to crflag
	else
		move FALSE to crflag
	endif
	reset linebuf
	scan LF in linebuf
	bump linebuf
	if (crflag)
		if (EOS)
			bump linebuf by -2
		else
			move linebuf to extrabuf
			bump linebuf by -3
		endif
	else
		if (eos)
			bump linebuf by -1
		else
			move linebuf to extrabuf
			bump linebuf by -2
		endif
	endif
	lenset linebuf
	reset linebuf		
	return
	endroutine

checkmethod	routine
	match "GET" to linebuf
	if (not equal)
		move "501" to errcode
		call starterr
		move SENDERR to state
		return
	endif		
	bump linebuf by 3
	if (eos)
		move "400" to errcode
		call starterr
		move SENDERR to state
		return
	endif
	loop
		cmatch 0x20 to linebuf
		if (not equal)
			break
		endif
		bump linebuf
		if (eos)
			move "400" to errcode
			call starterr
			move SENDERR to state
			return
		endif
	repeat
	cmatch "/" to linebuf
	if (not equal)
		move "400" to errcode
		call starterr
		move SENDERR to state
		return
	endif
	bump linebuf
	if (eos)
		move "index.html" to filename
		move REQINTWO to state
		return
	endif		
	cmatch 0x20 to linebuf
	if (not equal)
		move linebuf to filename
		call truncname
		bump linebuf by (size(filename))
		if (eos)
			move REQINTWO to state
			return
		endif
	else
		move "index.html" to filename
	endif
	loop
		cmatch 0x20 to linebuf
		if (not equal)
			break
		endif
		bump linebuf
		if (eos)
			move REQINTWO to state
			return
		endif
	repeat
	match "HTTP/" to linebuf
	if (not equal)
		move "400" to errcode
		call starterr
		move SENDERR to state
		return
	endif
	bump linebuf by 5
	if (eos)
		move "400" to errcode
		call starterr
		move SENDERR to state
		return
	endif
	cmatch "V" to linebuf
	if (equal)
		bump linebuf
	endif
	move linebuf to version
	move REQINTWO to state
	return
	endroutine

starterr		routine
	match "400" to errcode
	if (equal)
		pack databuf with errcode, " Bad Command", CR, LF
	else 
		pack databuf with errcode, " Not Implemented", CR, LF
	endif
	call prepsend
	send webchan, BLOCK; varsend
	return
	endroutine

prepsend		routine
varsize		num		4
	movesize databuf to varsize
	sformat varsend to varsize
	move databuf to varsend
	return
	endroutine

truncname		routine
	loop
		cmatch 0x20 to filename
		if (equal)
			break
		endif
		bump filename
		if (eos)
			reset filename
			return
		endif
	repeat
	lenset filename
	reset filename
	return
	endroutine

getline		routine
	move FALSE to gotline
	clear linebuf
	scan LF in extrabuf
	if (equal)
		reset extrabuf
		move extrabuf to linebuf
		clear extrabuf
	else
		append extrabuf to linebuf
		clear extrabuf
		loop
			recv webchan, BLOCK; databuf
			comtst webchan
			if (not over and less)		. success
				scan LF in databuf
				if (equal)
					append databuf to linebuf
					reset linebuf
					break
				else
					append databuf to linebuf
					reset linebuf
				endif
			else if (over and not less)	. pending
				append linebuf to extrabuf
				append databuf to extrabuf
				reset extrabuf
				return
			else						. error or clear
				call newchannel
				return
			endif
		repeat
	endif
	move TRUE to gotline
	return
	endroutine

	endclass

